//DirectSound Code

//Includes
//regular headers
#include <ostream>
#include <iostream>
//Created headers
#include "DXAudio.h"

//namespaces
using namespace std;

//Create sound manager
CSoundManager *dsound;

//sets up directsound objects and classes
int Init_DirectSound(HWND hwnd)
{
    HRESULT result;

    //create DirectSound manager object
    dsound = new CSoundManager();

    //initialize DirectSound
    result = dsound->Initialize(hwnd, DSSCL_PRIORITY);
    if (result != DS_OK)
	{
		cerr<<"DirectSound Initialize failed\n";
		return 0;}

    //set the primary buffer format
    result = dsound->SetPrimaryBufferFormat(2, 22050, 16);
    if (result != DS_OK)
	{
		cerr<<"SetPrimaryBufferFormat Failed\n";
		return 0;}

	cerr<<"DirectSound Initialized\n";

    //return success
    return 1;
}

//loads a sound into the proper csound object
CSound *LoadSound(char *filename)
{
    HRESULT result;

    //create local reference to wave data
    CSound *wave;

    //attempt to load the wave file
    result = dsound->Create(&wave, filename);
    if (result != DS_OK)
	{
		cerr<<"LoadSound() Create failed on file "<<filename<<endl;
		return NULL;}

	cerr<<"LoadSound() on file "<<filename<<" Successful\n";

    //return the wave
    return wave;
}

//play a sound
void PlaySound(CSound *sound)
{
    sound->Play();
}

//play a sound looped until stopped
void LoopSound(CSound *sound)
{
    sound->Play(0, DSBPLAY_LOOPING);
}

//stop a sound from playing
void StopSound(CSound *sound)
{
    sound->Stop();
}